Index: azure_iot_hub_riscv/trunk/app_iothub_client/kendryte/kpu.c
===================================================================
--- azure_iot_hub_riscv/trunk/app_iothub_client/kendryte/kpu.c	(revision 454)
+++ azure_iot_hub_riscv/trunk/app_iothub_client/kendryte/kpu.c	(revision 458)
@@ -1519,19 +1059,19 @@
 static void kpu_remove_padding(const kpu_model_remove_padding_layer_argument_t *arg, kpu_model_context_t *ctx)
 {
-    const uint8_t *src = (const uint8_t *)(ctx->main_buffer + arg->main_mem_in_address);
-    uint8_t *dest = (uint8_t *)(ctx->main_buffer + arg->main_mem_out_address);
-    uint32_t oc, channels = arg->channels;
-
-    for(oc = 0; oc < channels; oc++)
-        *dest++ = src[oc * 16];
+	const uint8_t *src = (const uint8_t *)(ctx->main_buffer + arg->main_mem_in_address);
+	uint8_t *dest = (uint8_t *)(ctx->main_buffer + arg->main_mem_out_address);
+	uint32_t oc, channels = arg->channels;
+
+	for (oc = 0; oc < channels; oc++)
+		*dest++ = src[oc * 16];
 }
 
 static void kpu_upload(const kpu_model_upload_layer_argument_t *arg, kpu_model_context_t *ctx)
 {
-    size_t width = arg->width;
-    size_t height = arg->height;
-    size_t channels = arg->channels;
-
-    kpu_upload_core(width, height, channels, ctx->main_buffer + arg->main_mem_in_address, arg->kpu_mem_out_address);
+	size_t width = arg->width;
+	size_t height = arg->height;
+	size_t channels = arg->channels;
+
+	kpu_upload_core(width, height, channels, ctx->main_buffer + arg->main_mem_in_address, arg->kpu_mem_out_address);
 }
 
@@ -1539,64 +1079,57 @@
 {
 #if FIX_CACHE
-    configASSERT(is_memory_cache((uintptr_t)buffer));
+	configASSERT(is_memory_cache((uintptr_t)buffer));
 #endif
-    uintptr_t base_addr = (uintptr_t)buffer;
-    const kpu_kmodel_header_t *header = (const kpu_kmodel_header_t *)buffer;
-
-    if (header->version == 3 && header->arch == 0)
-    {
-        ctx->is_nncase = 0;
-        ctx->model_buffer = buffer;
-        ctx->output_count = header->output_count;
-        ctx->outputs = (const kpu_model_output_t *)(base_addr + sizeof(kpu_kmodel_header_t));
-        ctx->layer_headers = (const kpu_model_layer_header_t *)((uintptr_t)ctx->outputs + sizeof(kpu_model_output_t) * ctx->output_count);
-        ctx->layers_length = header->layers_length;
-        ctx->body_start = (const uint8_t *)((uintptr_t)ctx->layer_headers + sizeof(kpu_model_layer_header_t) * header->layers_length);
-        ctx->main_buffer = (uint8_t *)malloc(header->main_mem_usage);
-        if (!ctx->main_buffer)
-            return -1;
-        uint32_t body_size = 0;
-        for (int i=0; i<ctx->layers_length; i++)
-        {
-            const kpu_model_layer_header_t *cnt_layer_header = ctx->layer_headers + i;
-            body_size += cnt_layer_header->body_size;
-        }
-        uint8_t *body_start_iomem = (uint8_t *)((uintptr_t)ctx->body_start - IOMEM);
-        const uint8_t *body_start_cache = ctx->body_start;
-        memcpy(body_start_iomem, body_start_cache, body_size);
-        for (int i=0; i<body_size; i++)
-        {
-            configASSERT(body_start_iomem[i] == body_start_cache[i]);
-        }
-        
-    } else
-    {
-        return -1;
-    }
-
-    return 0;
+	uintptr_t base_addr = (uintptr_t)buffer;
+	const kpu_kmodel_header_t *header = (const kpu_kmodel_header_t *)buffer;
+
+	if (header->version == 3 && header->arch == 0)
+	{
+		ctx->model_buffer = buffer;
+		ctx->output_count = header->output_count;
+		ctx->outputs = (const kpu_model_output_t *)(base_addr + sizeof(kpu_kmodel_header_t));
+		ctx->layer_headers = (const kpu_model_layer_header_t *)((uintptr_t)ctx->outputs + sizeof(kpu_model_output_t) * ctx->output_count);
+		ctx->layers_length = header->layers_length;
+		ctx->body_start = (const uint8_t *)((uintptr_t)ctx->layer_headers + sizeof(kpu_model_layer_header_t) * header->layers_length);
+		ctx->main_buffer = (uint8_t *)malloc(header->main_mem_usage);
+		if (!ctx->main_buffer)
+			return -1;
+		uint32_t body_size = 0;
+		for (int i = 0; i < ctx->layers_length; i++)
+		{
+			const kpu_model_layer_header_t *cnt_layer_header = ctx->layer_headers + i;
+			body_size += cnt_layer_header->body_size;
+		}
+		uint8_t *body_start_iomem = (uint8_t *)((uintptr_t)ctx->body_start - IOMEM);
+		const uint8_t *body_start_cache = ctx->body_start;
+		memcpy(body_start_iomem, body_start_cache, body_size);
+		for (int i = 0; i < body_size; i++)
+		{
+			configASSERT(body_start_iomem[i] == body_start_cache[i]);
+		}
+	}
+	else
+	{
+		return -1;
+	}
+
+	return 0;
 }
 
 int kpu_get_output(kpu_model_context_t *ctx, uint32_t index, uint8_t **data, size_t *size)
 {
-    if(ctx->is_nncase)
-        return -1;
-
-    if(index >= ctx->output_count)
-        return -1;
-
-    const kpu_model_output_t *output = ctx->outputs + index;
-    *data = ctx->main_buffer + output->address;
-    *size = output->size;
-    return 0;
+	if (index >= ctx->output_count)
+		return -1;
+
+	const kpu_model_output_t *output = ctx->outputs + index;
+	*data = ctx->main_buffer + output->address;
+	*size = output->size;
+	return 0;
 }
 
 void kpu_model_free(kpu_model_context_t *ctx)
 {
-    if(ctx->is_nncase)
-        return;
-
-    free(ctx->main_buffer);
-    ctx->main_buffer = NULL;
+	free(ctx->main_buffer);
+	ctx->main_buffer = NULL;
 }
 
@@ -1609,53 +1142,53 @@
 static const char *str_layer_type(uint32_t type)
 {
-    switch(type)
-    {
-        case KL_ADD:
-            return "Add";
-        case KL_QUANTIZED_ADD:
-            return "QuantAdd";
-        case KL_GLOBAL_AVERAGE_POOL2D:
-            return "GAP";
-        case KL_QUANTIZED_MAX_POOL2D:
-            return "QuantMaxPool2d";
-        case KL_AVERAGE_POOL2D:
-            return "AveragePool2d";
-        case KL_QUANTIZE:
-            return "Quantize";
-        case KL_DEQUANTIZE:
-            return "Dequantize";
-        case KL_REQUANTIZE:
-            return "Requantize";
-        case KL_L2_NORMALIZATION:
-            return "L2Norm";
-        case KL_SOFTMAX:
-            return "Softmax";
-        case KL_CONCAT:
-            return "Concat";
-        case KL_QUANTIZED_CONCAT:
-            return "QuantConcat";
-        case KL_FULLY_CONNECTED:
-            return "FullyConnected";
-        case KL_TENSORFLOW_FLATTEN:
-            return "TFFlatten";
-        case KL_RESIZE_NEAREST_NEIGHBOR:
-            return "ResizeNearestNeighbor";
-        case KL_QUANTIZED_RESIZE_NEAREST_NEIGHBOR:
-            return "QuantResizeNearestNeighbor";
-        case KL_CHANNELWISE_DEQUANTIZE:
-            return "ChannelwiseDequantize";
-        case KL_LOGISTIC:
-            return "Logistic";
-        case KL_K210_CONV:
-            return "K210Conv";
-        case KL_K210_ADD_PADDING:
-            return "K210AddPad";
-        case KL_K210_REMOVE_PADDING:
-            return "K210RemovePad";
-        case KL_K210_UPLOAD:
-            return "K210Upload";
-        default:
-            return "Unknown";
-    }
+	switch (type)
+	{
+	case KL_ADD:
+		return "Add";
+	case KL_QUANTIZED_ADD:
+		return "QuantAdd";
+	case KL_GLOBAL_AVERAGE_POOL2D:
+		return "GAP";
+	case KL_QUANTIZED_MAX_POOL2D:
+		return "QuantMaxPool2d";
+	case KL_AVERAGE_POOL2D:
+		return "AveragePool2d";
+	case KL_QUANTIZE:
+		return "Quantize";
+	case KL_DEQUANTIZE:
+		return "Dequantize";
+	case KL_REQUANTIZE:
+		return "Requantize";
+	case KL_L2_NORMALIZATION:
+		return "L2Norm";
+	case KL_SOFTMAX:
+		return "Softmax";
+	case KL_CONCAT:
+		return "Concat";
+	case KL_QUANTIZED_CONCAT:
+		return "QuantConcat";
+	case KL_FULLY_CONNECTED:
+		return "FullyConnected";
+	case KL_TENSORFLOW_FLATTEN:
+		return "TFFlatten";
+	case KL_RESIZE_NEAREST_NEIGHBOR:
+		return "ResizeNearestNeighbor";
+	case KL_QUANTIZED_RESIZE_NEAREST_NEIGHBOR:
+		return "QuantResizeNearestNeighbor";
+	case KL_CHANNELWISE_DEQUANTIZE:
+		return "ChannelwiseDequantize";
+	case KL_LOGISTIC:
+		return "Logistic";
+	case KL_K210_CONV:
+		return "K210Conv";
+	case KL_K210_ADD_PADDING:
+		return "K210AddPad";
+	case KL_K210_REMOVE_PADDING:
+		return "K210RemovePad";
+	case KL_K210_UPLOAD:
+		return "K210Upload";
+	default:
+		return "Unknown";
+	}
 }
 #endif
@@ -1663,210 +1196,241 @@
 static int kpu_kmodel_done(kpu_model_context_t *ctx)
 {
-    kpu->interrupt_clear.data = (kpu_config_interrupt_t){
-        .calc_done_int = 1,
-        .layer_cfg_almost_empty_int = 1,
-        .layer_cfg_almost_full_int = 1};
-    kpu->interrupt_mask.data = (kpu_config_interrupt_t){
-        .calc_done_int = 1,
-        .layer_cfg_almost_empty_int = 1,
-        .layer_cfg_almost_full_int = 1};
+	kpu->interrupt_clear.data = (kpu_config_interrupt_t){
+		.calc_done_int = 1,
+		.layer_cfg_almost_empty_int = 1,
+		.layer_cfg_almost_full_int = 1};
+	kpu->interrupt_mask.data = (kpu_config_interrupt_t){
+		.calc_done_int = 1,
+		.layer_cfg_almost_empty_int = 1,
+		.layer_cfg_almost_full_int = 1};
 #if KPU_DEBUG
-    uint32_t cnt_layer_id = ctx->current_layer - 1;
-    uint64_t time = sysctl_get_time_us();
-    if(last_time != 0)
-    {
-        uint64_t layer_time = time - last_time;
-        syslog(LOG_NOTICE, "layer %d [%s]: %f ms", cnt_layer_id, str_layer_type(last_layer_type), layer_time / 1000.0);
-        total_time += layer_time;
-        if(last_layer_type == KL_K210_CONV)
-            kpu_time += layer_time;
-    }
-
-    syslog(LOG_NOTICE, "KPU: %f ms", kpu_time / 1000.0);
-    syslog(LOG_NOTICE, "CPU: %f ms", (total_time - kpu_time) / 1000.0);
-    syslog(LOG_NOTICE, "Model: %f ms", total_time / 1000.0);
+	uint32_t cnt_layer_id = ctx->current_layer;
+	uint64_t time = sysctl_get_time_us();
+	if (last_time != 0)
+	{
+		uint64_t layer_time = time - last_time;
+		syslog(LOG_NOTICE, "layer %d/%d [%s]: %d.%03d ms", cnt_layer_id, ctx->layers_length, str_layer_type(last_layer_type), layer_time / 1000, layer_time % 1000);
+		total_time += layer_time;
+		if (last_layer_type == KL_K210_CONV)
+			kpu_time += layer_time;
+	}
+
+	syslog(LOG_NOTICE, "KPU: %d.%03d ms", kpu_time / 1000, kpu_time % 1000);
+	syslog(LOG_NOTICE, "CPU: %d.%03d ms", (total_time - kpu_time) / 1000, (total_time - kpu_time) % 1000);
+	syslog(LOG_NOTICE, "Model: %d.%03d ms", total_time / 1000, total_time % 1000);
 #endif
-    ctx->done_callback(ctx->userdata);
-    return 0;
+	ctx->done_callback(ctx->userdata);
+	return 0;
 }
 
 static int ai_step(void *userdata)
 {
-    kpu_model_context_t *ctx = (kpu_model_context_t *)userdata;
-
-    uint32_t cnt_layer_id = ctx->current_layer;
-    const uint8_t *layer_body = ctx->current_body;
-    const kpu_model_layer_header_t *cnt_layer_header = ctx->layer_headers + cnt_layer_id;
-    if (cnt_layer_id >= ctx->layers_length) {
-        //syslog(LOG_NOTICE, "overrun");
-        kpu_kmodel_done(ctx);
-        return -1;
-    }
-
-    ctx->current_layer++;
-    ctx->current_body += cnt_layer_header->body_size;
+	kpu_model_context_t *ctx = (kpu_model_context_t *)userdata;
+
+	uint32_t cnt_layer_id = ctx->current_layer;
+	const uint8_t *layer_body = ctx->current_body;
+	const kpu_model_layer_header_t *cnt_layer_header = ctx->layer_headers + cnt_layer_id;
+	if (cnt_layer_id >= ctx->layers_length)
+	{
+		//syslog(LOG_NOTICE, "overrun");
+		kpu_kmodel_done(ctx);
+		return -1;
+	}
+
+	ctx->current_layer++;
+	ctx->current_body += cnt_layer_header->body_size;
 
 #if KPU_DEBUG
-    uint64_t time = sysctl_get_time_us();
-    if(last_time != 0)
-    {
-        uint64_t layer_time = time - last_time;
-        syslog(LOG_NOTICE, "layer %d/%d [%s]: %d.%03d ms", cnt_layer_id, ctx->layers_length, str_layer_type(last_layer_type), layer_time / 1000, layer_time % 1000);
-        total_time += layer_time;
-        if(last_layer_type == KL_K210_CONV)
-            kpu_time += layer_time;
-    }
-
-    last_layer_type = cnt_layer_header->type;
-    last_time = sysctl_get_time_us();
+	uint64_t time = sysctl_get_time_us();
+	if (last_time != 0)
+	{
+		uint64_t layer_time = time - last_time;
+		syslog(LOG_NOTICE, "layer %d/%d [%s]: %d.%03d ms", cnt_layer_id, ctx->layers_length, str_layer_type(last_layer_type), layer_time / 1000, layer_time % 1000);
+		total_time += layer_time;
+		if (last_layer_type == KL_K210_CONV)
+			kpu_time += layer_time;
+	}
+
+	last_layer_type = cnt_layer_header->type;
+	last_time = sysctl_get_time_us();
 #endif
 
-    switch(cnt_layer_header->type)
-    {
-        case KL_ADD:
-            kpu_kmodel_add((const kpu_model_add_layer_argument_t *)layer_body, ctx);
-            break;
-        case KL_QUANTIZED_ADD:
-            kpu_quantized_add((const kpu_model_quant_add_layer_argument_t *)layer_body, ctx);
-            break;
-        case KL_GLOBAL_AVERAGE_POOL2D:
-            kpu_global_average_pool2d((const kpu_model_gap2d_layer_argument_t *)layer_body, ctx);
-            break;
-        case KL_QUANTIZED_MAX_POOL2D:
-            kpu_quantized_max_pool2d((const kpu_model_quant_max_pool2d_layer_argument_t *)layer_body, ctx);
-            break;
-        case KL_AVERAGE_POOL2D:
-            kpu_average_pool2d((const kpu_model_ave_pool2d_layer_argument_t *)layer_body, ctx);
-            break;
-        case KL_QUANTIZE:
-            kpu_quantize((const kpu_model_quantize_layer_argument_t *)layer_body, ctx);
-            break;
-        case KL_DEQUANTIZE:
-            kpu_kmodel_dequantize((const kpu_model_dequantize_layer_argument_t *)layer_body, ctx);
-            break;
-        case KL_REQUANTIZE:
-            kpu_requantize((const kpu_model_requantize_layer_argument_t *)layer_body, ctx);
-            break;
-        case KL_L2_NORMALIZATION:
-            kpu_l2_normalization((const kpu_model_l2_norm_layer_argument_t *)layer_body, ctx);
-            break;
-        case KL_SOFTMAX:
-            kpu_softmax((const kpu_model_softmax_layer_argument_t *)layer_body, ctx);
-            break;
-        case KL_CONCAT:
-        case KL_QUANTIZED_CONCAT:
-            kpu_concat((const kpu_model_concat_layer_argument_t *)layer_body, ctx);
-            break;
-        case KL_FULLY_CONNECTED:
-            kpu_kmodel_fully_connected((const kpu_model_fully_connected_layer_argument_t *)layer_body, ctx);
-            break;
-        case KL_TENSORFLOW_FLATTEN:
-            kpu_tf_flatten((const kpu_model_tf_flatten_layer_argument_t *)layer_body, ctx);
-            break;
-        case KL_RESIZE_NEAREST_NEIGHBOR:
-            kpu_resize_nearest_neighbor((const kpu_model_resize_nearest_neighbor_layer_argument_t *)layer_body, ctx);
-            break;
-        case KL_QUANTIZED_RESIZE_NEAREST_NEIGHBOR:
-            kpu_quant_resize_nearest_neighbor((const kpu_model_quant_resize_nearest_neighbor_layer_argument_t *)layer_body, ctx);
-            break;
-        case KL_CHANNELWISE_DEQUANTIZE:
-            kpu_kmodel_channelwise_dequantize((const kpu_model_channelwise_dequant_argument_t *)layer_body, ctx);
-            break;
-        case KL_LOGISTIC:
-            kpu_logistic((const kpu_model_logistic_layer_argument_t *)layer_body, ctx);
-            break;
-        case KL_K210_CONV:
-            kpu_conv((const kpu_model_conv_layer_argument_t *)layer_body, ctx);
-            return 0;
-        case KL_K210_ADD_PADDING:
-            kpu_add_padding((const kpu_model_add_padding_layer_argument_t *)layer_body, ctx);
-            break;
-        case KL_K210_REMOVE_PADDING:
-            kpu_remove_padding((const kpu_model_remove_padding_layer_argument_t *)layer_body, ctx);
-            break;
-        case KL_K210_UPLOAD:
-            kpu_upload((const kpu_model_upload_layer_argument_t *)layer_body, ctx);
-            break;
-        default:
-            assert(!"Layer is not supported.");
-            kpu_kmodel_done(ctx);
-            return -1;
-    }
-
-    if (ctx->current_layer < ctx->layers_length)
-        ai_step(userdata);
-    else
-        kpu_kmodel_done(ctx);
-    return 0;
+	switch (cnt_layer_header->type)
+	{
+	case KL_ADD:
+		kpu_kmodel_add((const kpu_model_add_layer_argument_t *)layer_body, ctx);
+		break;
+	case KL_QUANTIZED_ADD:
+		kpu_quantized_add((const kpu_model_quant_add_layer_argument_t *)layer_body, ctx);
+		break;
+	case KL_GLOBAL_AVERAGE_POOL2D:
+		kpu_global_average_pool2d((const kpu_model_gap2d_layer_argument_t *)layer_body, ctx);
+		break;
+	case KL_QUANTIZED_MAX_POOL2D:
+		kpu_quantized_max_pool2d((const kpu_model_quant_max_pool2d_layer_argument_t *)layer_body, ctx);
+		break;
+	case KL_AVERAGE_POOL2D:
+		kpu_average_pool2d((const kpu_model_ave_pool2d_layer_argument_t *)layer_body, ctx);
+		break;
+	case KL_QUANTIZE:
+		kpu_quantize((const kpu_model_quantize_layer_argument_t *)layer_body, ctx);
+		break;
+	case KL_DEQUANTIZE:
+		kpu_kmodel_dequantize((const kpu_model_dequantize_layer_argument_t *)layer_body, ctx);
+		break;
+	case KL_REQUANTIZE:
+		kpu_requantize((const kpu_model_requantize_layer_argument_t *)layer_body, ctx);
+		break;
+	case KL_L2_NORMALIZATION:
+		kpu_l2_normalization((const kpu_model_l2_norm_layer_argument_t *)layer_body, ctx);
+		break;
+	case KL_SOFTMAX:
+		kpu_softmax((const kpu_model_softmax_layer_argument_t *)layer_body, ctx);
+		break;
+	case KL_CONCAT:
+	case KL_QUANTIZED_CONCAT:
+		kpu_concat((const kpu_model_concat_layer_argument_t *)layer_body, ctx);
+		break;
+	case KL_FULLY_CONNECTED:
+		kpu_kmodel_fully_connected((const kpu_model_fully_connected_layer_argument_t *)layer_body, ctx);
+		break;
+	case KL_TENSORFLOW_FLATTEN:
+		kpu_tf_flatten((const kpu_model_tf_flatten_layer_argument_t *)layer_body, ctx);
+		break;
+	case KL_RESIZE_NEAREST_NEIGHBOR:
+		kpu_resize_nearest_neighbor((const kpu_model_resize_nearest_neighbor_layer_argument_t *)layer_body, ctx);
+		break;
+	case KL_QUANTIZED_RESIZE_NEAREST_NEIGHBOR:
+		kpu_quant_resize_nearest_neighbor((const kpu_model_quant_resize_nearest_neighbor_layer_argument_t *)layer_body, ctx);
+		break;
+	case KL_CHANNELWISE_DEQUANTIZE:
+		kpu_kmodel_channelwise_dequantize((const kpu_model_channelwise_dequant_argument_t *)layer_body, ctx);
+		break;
+	case KL_LOGISTIC:
+		kpu_logistic((const kpu_model_logistic_layer_argument_t *)layer_body, ctx);
+		break;
+	case KL_K210_CONV:
+		kpu_conv((const kpu_model_conv_layer_argument_t *)layer_body, ctx);
+		return 0;
+	case KL_K210_ADD_PADDING:
+		kpu_add_padding((const kpu_model_add_padding_layer_argument_t *)layer_body, ctx);
+		break;
+	case KL_K210_REMOVE_PADDING:
+		kpu_remove_padding((const kpu_model_remove_padding_layer_argument_t *)layer_body, ctx);
+		break;
+	case KL_K210_UPLOAD:
+		kpu_upload((const kpu_model_upload_layer_argument_t *)layer_body, ctx);
+		break;
+	default:
+		assert(!"Layer is not supported.");
+		kpu_kmodel_done(ctx);
+		return -1;
+	}
+
+	if (ctx->current_layer < (ctx->layers_length - 1))
+		ai_step(userdata);
+	else
+		kpu_kmodel_done(ctx);
+	return 0;
 }
 
 static void ai_step_not_isr(void *userdata)
 {
-    sysctl_disable_irq();
-    ai_step(userdata);
-    sysctl_enable_irq();
+	dis_int(INTNO_DMAAI);
+	dis_int(INTNO_AI);
+
+	ai_step(userdata);
+
+	ena_int(INTNO_DMAAI);
+	ena_int(INTNO_AI);
 }
 
 int kpu_run_kmodel(kpu_model_context_t *ctx, const uint8_t *src, dmac_channel_number_t dma_ch, kpu_done_callback_t done_callback, void *userdata)
 {
-    if(ctx->is_nncase)
-        return -1;
-
-    ctx->dma_ch = dma_ch;
-    ctx->done_callback = done_callback;
-    ctx->userdata = userdata;
-    ctx->current_layer = 0;
-    ctx->current_body = ctx->body_start;
+	ctx->dma_ch = dma_ch;
+	ctx->done_callback = done_callback;
+	ctx->userdata = userdata;
+	ctx->current_layer = 0;
+	ctx->current_body = ctx->body_start;
 #if KPU_DEBUG
-    last_time = 0;
-    total_time = 0;
-    kpu_time = 0;
+	last_time = 0;
+	total_time = 0;
+	kpu_time = 0;
 #endif
 
-    kpu_kmodel_header_t *header = (kpu_kmodel_header_t *)ctx->model_buffer;
-    kpu->interrupt_clear.reg = 7;
-    kpu->fifo_threshold.data = (kpu_config_fifo_threshold_t){
-        .fifo_full_threshold = 10, .fifo_empty_threshold = 1};
-    kpu->eight_bit_mode.data = (kpu_config_eight_bit_mode_t){
-        .eight_bit_mode = header->flags & 1};
-    kpu->interrupt_mask.data = (kpu_config_interrupt_t){
-        .calc_done_int = 1,
-        .layer_cfg_almost_empty_int = 0,
-        .layer_cfg_almost_full_int = 1};
-
-    plic_set_priority(INTNO_AI, 1);
-    plic_irq_register(INTNO_AI, ai_step, ctx);
-    plic_irq_enable(INTNO_AI);
-
-    const kpu_model_layer_header_t *first_layer_header = ctx->layer_headers;
-
-    switch(first_layer_header->type)
-    {
-        case KL_K210_CONV:
-        {
-            const kpu_model_conv_layer_argument_t *first_layer = (const kpu_model_conv_layer_argument_t *)ctx->body_start;
-            kpu_layer_argument_t layer_arg = *(volatile kpu_layer_argument_t *)(ctx->model_buffer + first_layer->layer_offset);
-
-            if((layer_arg.image_size.data.i_row_wid + 1) % 64 != 0)
-            {
-                kpu_kmodel_input_with_padding(&layer_arg, src);
-                ai_step_not_isr(ctx);
-            } else
-            {
-                kpu_input_dma(&layer_arg, src, ctx->dma_ch, ai_step, ctx);
-            }
-        }
-        break;
-        case KL_FULLY_CONNECTED:
-        {
-            const kpu_model_fully_connected_layer_argument_t *first_layer = (const kpu_model_fully_connected_layer_argument_t *)ctx->body_start;
-            kpu_kmodel_input_float((const float *)src, (float *)(ctx->main_buffer + first_layer->main_mem_in_address), first_layer->in_channels);
-            ai_step_not_isr(ctx);
-        }
-        break;
-        default:
-            return -1;
-    }
-
-    return 0;
-}
+	kpu_kmodel_header_t *header = (kpu_kmodel_header_t *)ctx->model_buffer;
+	kpu->interrupt_clear.reg = 7;
+	kpu->fifo_threshold.data = (kpu_config_fifo_threshold_t){
+		.fifo_full_threshold = 10, .fifo_empty_threshold = 1};
+	kpu->eight_bit_mode.data = (kpu_config_eight_bit_mode_t){
+		.eight_bit_mode = header->flags & 1};
+	kpu->interrupt_mask.data = (kpu_config_interrupt_t){
+		.calc_done_int = 1,
+		.layer_cfg_almost_empty_int = 0,
+		.layer_cfg_almost_full_int = 1};
+
+	//plic_set_priority(INTNO_AI, 1);
+	plic_irq_register(INTNO_AI, ai_step, ctx);
+	plic_irq_enable(INTNO_AI);
+
+	const kpu_model_layer_header_t *first_layer_header = ctx->layer_headers;
+
+	switch (first_layer_header->type)
+	{
+	case KL_K210_CONV:
+	{
+		const kpu_model_conv_layer_argument_t *first_layer = (const kpu_model_conv_layer_argument_t *)ctx->body_start;
+		kpu_layer_argument_t layer_arg = *(volatile kpu_layer_argument_t *)(ctx->model_buffer + first_layer->layer_offset);
+
+		if ((layer_arg.image_size.data.i_row_wid + 1) % 64 != 0)
+		{
+			kpu_kmodel_input_with_padding(&layer_arg, src);
+			ai_step_not_isr(ctx);
+		}
+		else
+		{
+			kpu_input_dma(&layer_arg, src, ctx->dma_ch, ai_step, ctx);
+		}
+	}
+	break;
+	case KL_FULLY_CONNECTED:
+	{
+		const kpu_model_fully_connected_layer_argument_t *first_layer = (const kpu_model_fully_connected_layer_argument_t *)ctx->body_start;
+		kpu_kmodel_input_float((const float *)src, (float *)(ctx->main_buffer + first_layer->main_mem_in_address), first_layer->in_channels);
+		ai_step_not_isr(ctx);
+	}
+	break;
+	default:
+		return -1;
+	}
+
+	return 0;
+}
+
+ER kpu_init(kpu_model_context_t *ctx)
+{
+	g_ai_hdma.chnum = AI_DMA_CH;
+	g_ai_hdma.xfercallback = ai_dma_done_isr;
+	g_ai_hdma.errorcallback = NULL;
+	g_ai_hdma.Init.Request = DMA_SELECT_AI_RX_REQ;		/* DMA選択 */
+	g_ai_hdma.Init.Direction = DMA_PERIPH_TO_MEMORY;	/* DMA転送方向 */
+	g_ai_hdma.Init.SrcMultBlock = DMAC_MULTBLOCK_CONT;	/* ソースマルチブロックタイプ */
+	g_ai_hdma.Init.DrcMultBlock = DMAC_MULTBLOCK_CONT;	/* デスティネーションマルチブロックタイプ */
+	g_ai_hdma.Init.SrcHandShake = DMAC_HS_HARDWARE;		/* ソースハンドシェイク */
+	g_ai_hdma.Init.DrcHandShake = DMAC_HS_SOFTWARE;		/* デスティネーションハンドシェイク */
+	g_ai_hdma.Init.SrcHwhsPol = DMAC_HWHS_POLARITY_LOW; /* ソースハードウェアハンドシェイク極性 */
+	g_ai_hdma.Init.DrcHwhsPol = DMAC_HWHS_POLARITY_LOW; /* デスティネーションハードウェアハンドシェイク極性 */
+	g_ai_hdma.Init.Priority = 4;						/* 優先度 */
+	g_ai_hdma.Init.SrcMaster = DMAC_MASTER1;			/* ソースマスター設定 */
+	g_ai_hdma.Init.DstMaster = DMAC_MASTER2;			/* デスティネーションマスター設定 */
+	g_ai_hdma.Init.SrcInc = DMAC_ADDR_NOCHANGE;			/* ソースインクリメント設定 */
+	g_ai_hdma.Init.DstInc = DMAC_ADDR_INCREMENT;		/* デスティネーションインクリメント設定 */
+	g_ai_hdma.Init.SrcTransWidth = DMAC_TRANS_WIDTH_32; /* ソース転送幅 */
+	g_ai_hdma.Init.DstTransWidth = DMAC_TRANS_WIDTH_32; /* デスティネーション転送幅 */
+	g_ai_hdma.Init.SrcBurstSize = DMAC_MSIZE_4;			/* ソースバーストサイズ */
+	g_ai_hdma.Init.DstBurstSize = DMAC_MSIZE_4;			/* デスティネーションバーストサイズ */
+	g_ai_hdma.Init.IocBlkTrans = 0;						/* IOCブロック転送 */
+	g_ai_hdma.localdata = (void *)ctx;
+
+	return dma_init(&g_ai_hdma);
+}
